/*
 * 商户实名信息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MerchantAuthController : BaseController
    {
        public MerchantAuthController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商户实名信息列表

        /// <summary>
        /// 根据条件查询商户实名信息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MerchantAuth data, string right, string MerchantId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;


            string Condition = "";
            Condition += "ChannelCode:\"" + data.ChannelCode + "\",";
Condition += "ChannelName:\"" + data.ChannelName + "\",";
Condition += "MerNo:\"" + data.MerNo + "\",";
Condition += "RealName:\"" + data.RealName + "\",";
Condition += "IdCardNo:\"" + data.IdCardNo + "\",";
Condition += "BankCardAccount:\"" + data.BankCardAccount + "\",";
Condition += "BankName:\"" + data.BankName + "\",";
Condition += "BankMobile:\"" + data.BankMobile + "\",";
Condition += "AuthType:\"" + data.AuthType + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询商户实名信息列表

        /// <summary>
        /// 商户实名信息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MerchantAuth data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("MerchantId", "1");

            Fields.Add("ChannelCode", "2"); //渠道编码
Fields.Add("CreateDate", "3"); //时间
Fields.Add("ChannelName", "2"); //渠道名称	
Fields.Add("MerNo", "2"); //商户编号
Fields.Add("RealName", "2"); //真实姓名
Fields.Add("IdCardNo", "2"); //身份证号
Fields.Add("BankCardAccount", "2"); //银行卡账号
Fields.Add("BankName", "2"); //银行名称
Fields.Add("BankMobile", "2"); //银行预留手机号码
Fields.Add("AuthType", "1"); //实名类型

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantAuth", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }
            return Json(obj);
        }

        #endregion

        #region 增加商户实名信息

        /// <summary>
        /// 增加或修改商户实名信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string MerchantId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;


            return View();
        }

        #endregion

        #region 增加商户实名信息

        /// <summary>
        /// 增加或修改商户实名信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MerchantAuth data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("MerchantId", data.MerchantId);

            Fields.Add("ChannelCode", data.ChannelCode); //渠道编码
Fields.Add("ChannelName", data.ChannelName); //渠道名称	
Fields.Add("MerNo", data.MerNo); //商户编号
Fields.Add("RealName", data.RealName); //真实姓名
Fields.Add("IdCardNo", data.IdCardNo); //身份证号
Fields.Add("BankCardAccount", data.BankCardAccount); //银行卡账号
Fields.Add("BankName", data.BankName); //银行名称
Fields.Add("BankMobile", data.BankMobile); //银行预留手机号码
Fields.Add("ReqData", data.ReqData); //渠道请求报文
Fields.Add("RespData", data.RespData); //渠道响应报文
Fields.Add("ReturnCode", data.ReturnCode); //渠道返回编码
Fields.Add("ReturnMsg", data.ReturnMsg); //渠道返回信息
Fields.Add("AuthType", data.AuthType); //实名类型

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MerchantAuth", Fields, 0);
            AddSysLog(data.Id.ToString(), "MerchantAuth", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改商户实名信息

        /// <summary>
        /// 增加或修改商户实名信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string MerchantId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;


            MerchantAuth editData = db.MerchantAuth.FirstOrDefault(m => m.Id == Id) ?? new MerchantAuth();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商户实名信息

        /// <summary>
        /// 增加或修改商户实名信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MerchantAuth data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("MerchantId", data.MerchantId);

            Fields.Add("ChannelCode", data.ChannelCode); //渠道编码
Fields.Add("ChannelName", data.ChannelName); //渠道名称	
Fields.Add("MerNo", data.MerNo); //商户编号
Fields.Add("RealName", data.RealName); //真实姓名
Fields.Add("IdCardNo", data.IdCardNo); //身份证号
Fields.Add("BankCardAccount", data.BankCardAccount); //银行卡账号
Fields.Add("BankName", data.BankName); //银行名称
Fields.Add("BankMobile", data.BankMobile); //银行预留手机号码
Fields.Add("ReqData", data.ReqData); //渠道请求报文
Fields.Add("RespData", data.RespData); //渠道响应报文
Fields.Add("ReturnCode", data.ReturnCode); //渠道返回编码
Fields.Add("ReturnMsg", data.ReturnMsg); //渠道返回信息
Fields.Add("AuthType", data.AuthType); //实名类型

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantAuth", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MerchantAuth","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除商户实名信息信息

        /// <summary>
        /// 删除商户实名信息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MerchantAuth","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantAuth", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MerchantAuth","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantAuth", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MerchantAuth","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantAuth", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MerchantAuth", Sort, Id);
            
            AddSysLog(Id.ToString(), "MerchantAuth", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.MerchantAuth.Add(new MerchantAuth()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "MerchantAuth", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MerchantAuth data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ChannelCode", "2"); //渠道编码
Fields.Add("CreateDate", "3"); //时间
Fields.Add("ChannelName", "2"); //渠道名称	
Fields.Add("MerNo", "2"); //商户编号
Fields.Add("RealName", "2"); //真实姓名
Fields.Add("IdCardNo", "2"); //身份证号
Fields.Add("BankCardAccount", "2"); //银行卡账号
Fields.Add("BankName", "2"); //银行名称
Fields.Add("BankMobile", "2"); //银行预留手机号码
Fields.Add("AuthType", "1"); //实名类型

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantAuth", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MerchantAuth", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
